'Bambino-02
SERTXD("B02",CR)    'report program number

#PicAxe 20M2
#no_data

'Bambino-02  Test PWM of eyeLEDs
'-----------------------------------------------------------------
Rationale:
'The only way to see what is the effects of different PWM values 
'is to try them and see.
'The following code PWMs the Eye LEDs,
'first the Right eye at 10KHz then the Left Eye at ~40kHz
'first the Right eye at 10KHz then the Left Eye at ~4kHz
'Since to me there is no visual difference I think it is easier to use
'period =24, then duty can run from 100 to 0 same as a percentage.
'=================================================================
SYMBOL VoiceLedpin_     =c.5    'low =>LED on
SYMBOL eyeLedLpin_      =c.2    'low =>LED on
SYMBOL eyeLedRpin_      =b.1    'low =>LED on
SYMBOL GwhiskerLedLpin_ =c.3    'low =>Ground whisker LED on
SYMBOL GwhiskerLedRpin_ =b.3    'low =>Ground whisker LED on

SYMBOL t  =50   'pause time


'PWMOUT pin, period, duty cycles
'period 0 to 255, duty cycles 0 to 1023

'The PWM period = (period + 1) x 4 x resonator speed
'(resonator speed for 4MHz = 1/4000000)
'The PWM duty cycle = (duty) x resonator speed

'What this means is that the duty cycle value is in units of processor cycles,
'and the period is in units of 4 processor cycles.
'The PWM on-time can not be greater than the PWM period
'so the maximum duty cycles, ie the PWM on-time, is (period + 1)*4

'hence @4MHz
'The PWM period = (period + 1) x 4 x (1/4000000) seconds
'               = (period + 1) / 1000000  seconds
'               = (period + 1) microseconds
'The PWM frequency is 1 / PWM period
'for a period of 99
'   The PWM frequency is 1 / (99 + 1) microseconds
'ie The PWM frequency is 1000 / 100 ie 10 KHz
'for a period of 255
'   The PWM frequency is 1 / (255 + 1) microseconds
'ie The PWM frequency is 1000 / 256 ie  just under 4 KHz

'The following code PWMs the Eye LEDs,
'first the Right eye at 10KHz then the Left Eye at ~40kHz
'first the Right eye at 10KHz then the Left Eye at ~4kHz
'Since to me there is no visual difference I think it is easier to use
'period =24, then duty can run from 100 to 0 same as a percentage.

'==================================================
initialise:
  HIGH eyeLedLpin_           'make output and turn off
  HIGH eyeLedRpin_           'make output and turn off
  HIGH GwhiskerLedLpin_      'make output and turn off
  HIGH GwhiskerLedRpin_      'make output and turn off

start:

'-------------------------
  HIGH VoiceLedpin_   'LED off

'period =99    'at 4mHz => (99+1)*4 =400 uS
'so max duty count =400
'period in uS =(99+1)*4/freq    @4MHz =>(99+1)*4/4000000 =>1/10000
'PWMfrequency =1/period =1/10,000 => 10KHz

  PWMOUT eyeLedRpin_,99,0   'bright   +
  PAUSE t
  PWMOUT eyeLedRpin_,99,210 'dimmer   +210 ~192
  PAUSE t
  PWMOUT eyeLedRpin_,99,306 'dimmer   +96
  PAUSE t
  PWMOUT eyeLedRpin_,99,354 'dimmer   +48
  PAUSE t
  PWMOUT eyeLedRpin_,99,378 'dimmer   +24
  PAUSE t
  PWMOUT eyeLedRpin_,99,390 'dimmer   +12
  PAUSE t
  PWMOUT eyeLedRpin_,99,396 'dimmer   +6
  PAUSE t
  PWMOUT eyeLedRpin_,99,399 'dimmer   +3
  PAUSE t
'  PWMOUT eyeLedRpin_,99,400 'off
  PWMOUT eyeLedRpin_,off
  PAUSE 500

'period =24    'at 4mHz => (24+1)*4 =100 uS
'so max duty count =100
'period in uS =(24+1)*4/freq    @4MHz =>(24+1)*4/4000000 =>25/1000000
'period =100/4M =25/1,000,000 => 40KHz

  PWMOUT eyeLedLpin_,24,0    'bright
  PAUSE t
  PWMOUT eyeLedLpin_,24,41  'dimmer   +41
  PAUSE t
  PWMOUT eyeLedLpin_,24,67  'dimmer   +26
  PAUSE t
  PWMOUT eyeLedLpin_,24,82  'dimmer   +15
  PAUSE t
  PWMOUT eyeLedLpin_,24,90  'dimmer   +8
  PAUSE t
  PWMOUT eyeLedLpin_,24,96  'dimmer   +4
  PAUSE t
  PWMOUT eyeLedLpin_,24,98  'dimmer   +2
  PAUSE t
  PWMOUT eyeLedLpin_,24,99  'dimmer   +1
  PAUSE t
'  PWMOUT eyeLedLpin_,24,100 'off
  PWMOUT eyeLedLpin_,off
  PAUSE 500

'-------------------------
  LOW VoiceLedpin_   'LED on

'period =99    'at 4mHz => (99+1)*4 =400 uS
'so max duty count =400
'period in uS =(99+1)*4/freq    @4MHz =>(99+1)*4/4000000 =>1/10000
'PWMfrequency =1/period =1/10,000 => 10KHz

  PWMOUT eyeLedRpin_,99,0   'bright   +
  PAUSE t
  PWMOUT eyeLedRpin_,99,210 'dimmer   +210 ~192
  PAUSE t
  PWMOUT eyeLedRpin_,99,306 'dimmer   +96
  PAUSE t
  PWMOUT eyeLedRpin_,99,354 'dimmer   +48
  PAUSE t
  PWMOUT eyeLedRpin_,99,378 'dimmer   +24
  PAUSE t
  PWMOUT eyeLedRpin_,99,390 'dimmer   +12
  PAUSE t
  PWMOUT eyeLedRpin_,99,396 'dimmer   +6
  PAUSE t
  PWMOUT eyeLedRpin_,99,399 'dimmer   +3
  PAUSE t
'  PWMOUT eyeLedRpin_,99,400 'off
  PWMOUT eyeLedRpin_,off
  PAUSE 500

'period =255    'at 4mHz => (255+1)*4 =1024 uS
'so max duty count =1024
'but can't do 1024 as parameter max is 1023 and 1023+1 wraps round to 0
'period in uS =(255+1)*4/freq    @4MHz =>(255+1)*4/4000000 =>256/1000000
'period =1024/4M =256/1,000,000 => ~4KHz

  PWMOUT eyeLedLpin_,255,0    'bright
  PAUSE t
  PWMOUT eyeLedLpin_,255,515  'dimmer   +515 ~512
  PAUSE t
  PWMOUT eyeLedLpin_,255,771  'dimmer   +256
  PAUSE t
  PWMOUT eyeLedLpin_,255,899  'dimmer   +128
  PAUSE t
  PWMOUT eyeLedLpin_,255,963  'dimmer   +64
  PAUSE t
  PWMOUT eyeLedLpin_,255,995  'dimmer   +32
  PAUSE t
  PWMOUT eyeLedLpin_,255,1011 'dimmer   +16
  PAUSE t
  PWMOUT eyeLedlpin_,255,1019 'dimmer   +8
  PAUSE t
  PWMOUT eyeLedLpin_,255,1023 'dimmest   +4
  PAUSE t
  PWMOUT eyeLedLpin_,off
  PAUSE 500

  GOTO start
'==================================================


