'Bambino-04
SERTXD("B04",CR)    'report program number

#PicAxe 20M2
#no_data

'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values

'-----------------------------------------------------------------
Rationale:
'Test Eye light values
'---------------------
'  open the Terminal window [F8] to see the values;
'    set the baud to 4800;
'  read the analog light values using READADC
'=================================================================

SYMBOL VoiceLedpin_     =c.5
SYMBOL eyeLedLpin_      =c.2    'low =>LED on
SYMBOL eyeLedRpin_      =b.1    'low =>LED on
SYMBOL whiskerLedLpin_  =c.3    'low =>whisker LED on
SYMBOL whiskerLedRpin_  =b.3    'low =>whisker LED on
SYMBOL inIRpin          =c.6
SYMBOL eyeRpin          =c.7
SYMBOL eyeLpin          =c.1

SYMBOL dark          =B1
SYMBOL light         =B2
SYMBOL diffpercent   =B3

initialise:
  HIGH eyeLedRpin_          'make output LED off
  HIGH eyeLedLpin_          'make output LED off

start:
  HIGH  eyeLedRpin_         'eyeR off

QEyeL:                      'Query Eye Left
  READADC eyeLpin,dark      'dark eyval in b1
  LOW eyeLedLpin_           'eyeR on
  PAUSE 1
  READADC eyeLpin,light     'light eyeval in b2
                            'and use pin name eyeLpin instead of c.1, 
                            'just to show it works
  HIGH  eyeLedLpin_         'eyeR off
  IF dark>light THEN QEyeL  'interference
  dark  =dark MIN 1         'if b1=0 then b3=100% which is wrong
  light =light MIN 1        'if b2=0 then b3=255 which is wrong
  diffpercent =light -dark *100 /dark MAX 255
                            'scale as % of dark
                            'max 255 so it doesn't wrap round
  SERTXD ("L dark=",#dark," light=",#light," diff%=",#diffpercent," :")
                            'send value to PC
  PAUSE 100

QEyeR:                      'Query Eye Right
  READADC eyeRpin,dark      'dark eyval in b1
  LOW eyeLedRpin_           'eyeR on
  PAUSE 1
  READADC eyeRpin,light     'light eyeval in b2
                            'and use pin name eyeRpin instead of c.7, 
                            'just to show it works
  HIGH  eyeLedRpin_         'eyeR off
  IF dark>light THEN QEyeR  'interference
  dark  =dark MIN 1         'if b1=0 then b3=100% which is wrong
  light =light MIN 1        'if b2=0 then b3=255 which is wrong
  diffpercent =light -dark *100 /dark MAX 255 'scale as % of dark
                            'max 255 so it doesn't wrap round
  SERTXD ("R dark=",#dark," light=",#light," diff%=",#diffpercent," :")
                            'send value to PC
  PAUSE 100

  SERTXD (CR)               'new line
  GOTO start                'loop back to start

'=================================================================
