'Bambino-13
SERTXD("B13",CR)    'report program number

#PicAxe 20M2
#no_data

'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values
'Bambino-06  Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-07  Set servos to mid position
'Bambino-08  Calibrate servo mid positions and put in EEPROM.
'Bambino-08+ Adjust servo mid positions from Handset and put in EEPROM.
'Bambino-09  Introduce _iStand:- initialise with feet in mid position
'Bambino-10  Set rollby, rollbymax for Roll Right
'Bambino-11  Check rollby, rollbymax for Roll Left
'Bambino-12  Check rollby and rollbymax for rollL, rollR
'Bambino-13  Introduction of _Stand

'-----------------------------------------------------------------
Rationale:
'rollby is now a variable and read from rollbyL and rollbyR in EEPROM
'
'Introduction of _Stand
'----------------------
'You might have to take out the download cable to
'check what is right, because it pulls the robot.

'Bambino -
'Rolls onto its Right foot
'Rolls onto its Left foot
'four times so we can see how Bambino rolls from one foot to the other
'
'Bambino then -
'Rolls onto its Right foot
'Stands upright using _Stand
'Rolls onto its Left foot
'Stands upright using _Stand
'four times so we can see how Bambino rolls from a foot to standing
'
'As you can see there is little difference, however ending each move
'with Stand means that at the end of a move Bambino is in a known Pose.
'=================================================================
'modified
'--------
'start:

'New
'---
'Stand  'stand with both feet flat
'=================================================================

SYMBOL servopacepin      =c.0  'left connector
SYMBOL servorollpin      =c.4  'right connector
SYMBOL VoiceLedpin_      =c.5
SYMBOL eyeLedLpin_       =c.2  'low =>LED on
SYMBOL eyeLedRpin_       =b.1  'low =>LED on
SYMBOL whiskerLedLpin_   =c.3  'low =>whisker LED on
SYMBOL whiskerLedRpin_   =b.3  'low =>whisker LED on
SYMBOL IRinpin           =c.6
SYMBOL IRoutpin          =b.2

SYMBOL temp0        =B0
'symbol cmnd         =B1
SYMBOL Scentre    =W1
SYMBOL  rollC       =B2  '100 is roll to the left, 200 to the right
SYMBOL  paceC       =B3  '100 is left foot back, 200 left foot forward
SYMBOL Sat        =W2    'current servo positions
SYMBOL  rollat      =B4
SYMBOL  paceat      =B5
SYMBOL Sto        =W3    'desired servo positions
SYMBOL  rollto      =B6
SYMBOL  paceto      =B7
SYMBOL i            =B8
SYMBOL spulse       =B9

'=== Your Bambino ================
SYMBOL rollby     =15  '15 good for walking, edit to value in program11
SYMBOL rollspeed  =3   '4 is too fast, 0 won't move
SYMBOL sframe     =20  'time between servo pulses
SYMBOL rollbymax  =20  '@speed 3; 25@speed 1
'rollmax absolute max is 40, above that the tilt rods hit the body

'EEPROM DATA
SYMBOL DrollC =254  'holds rollC, 100 is roll to the left, 150 is nominal centre
SYMBOL DpaceC =255  'holds paceC, 100 is left foot back,   150 is nominal centre
'=================================

initialise:
  'get values from EEPROM set by program #8 or #8+
  READ DrollC,rollC
  READ DpaceC,paceC
  SERTXD("rollC=",#rollC," paceC=",#paceC,CR)

  LOW eyeLedRpin_     'make output
  HIGH eyeLedLpin_    'make output
  GOSUB _iStand


start:
  FOR i=1 TO 4
    TOGGLE eyeLedRpin_  'alter eyeR so we know program is running
    TOGGLE eyeLedLpin_  'alter eyeR so we know program is running
    GOSUB _rollL
    TOGGLE eyeLedRpin_  'alter eyeR so we know program is running
    TOGGLE eyeLedLpin_  'alter eyeR so we know program is running
    GOSUB _rollR
   NEXT i
  GOSUB Stand 
  FOR i=1 TO 4
    'don't alter eyes so we know we are in this section
    GOSUB _rollR
    GOSUB Stand
    GOSUB _rollL
    GOSUB Stand
   NEXT i
  GOTO start



Stand:                        'stand with both feet flat
  IF rollat<rollC THEN _StandR
_StandL:
  FOR spulse=rollat TO rollC STEP -rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat  'pulse servo
    PAUSE sframe
   NEXT spulse
  RETURN
_StandR:
  FOR spulse=rollat TO rollC STEP rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat  'pulse servo
    PAUSE sframe
   NEXT spulse
  RETURN

_rollL:
  rollto =rollC -rollby
  FOR spulse=rollat TO rollto STEP -rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat  'pulse servo
    PAUSE sframe
   NEXT spulse
  RETURN

_rollR:
  rollto =rollC +rollby
  FOR spulse=rollat TO rollto STEP rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat 'pulse servo
    PAUSE sframe
   NEXT spulse
  RETURN

_iStand:                       'initialise with feet in mid position
  FOR i=0 TO 20
    PULSOUT servopacepin,paceC 'pulse servo paceC
    PULSOUT servorollpin,rollC 'pulse servo rollC
    PAUSE 70                   'pause 70ms - do it slowly
   NEXT i
  rollat =rollC
  RETURN
  
'=================================================================  