'Bambino-25
SERTXD("B25",CR)    'report program number

'661 bytes

#PicAxe 20M2
#no_data

'=================================================================
'PICAXE            IC   Memory   ext  I/O   Outputs  Inputs  ADC  Memory                        Starts  Polled  Resonator
'    Type        pins  bytes    slot pins                        Vars. RAM Spad Data     Table*        Int.    def. opt.
'2.28 PICAXE-20M2  20    2k           18    1-16     1-17     4    28   512      256      512   8       Yes      4   -32

'PICAXE-20M2 circuit board with LEDs off takes 1mA
'PICAXE-20M2 circuit board with LEDs off and servos connected takes 10mA

'=================================================================
'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values
'Bambino-06  Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-07  Set servos to mid position
'Bambino-08  Calibrate servo mid positions and put in EEPROM.
'Bambino-08+ Adjust servo mid positions from Handset and put in EEPROM.
'Bambino-09  Introduce _iStand:- initialise with feet in mid position
'Bambino-10  Set rollby, rollbymax for Roll Right
'Bambino-11  Check rollby, rollbymax for Roll Left
'Bambino-12  Check rollby and rollbymax for rollL, rollR
'Bambino-13  Introduction of _Stand
'Bambino-14  Investigate effect of rollspeed;
'            watch roll for all three speeds
'Bambino-15  Investigate effect of rollspeed;
'            watch Roll and Stand for all three speeds
'Bambino-16  Check paceFL paceFR;  Investigate effect of pacespeed
'            Introduction of pulseservos:
'Bambino-17  Check Fd
'Bambino-18  Test Rt, Lt
'Bambino-19  Test Bk
'Bambino-20  Test T2l: TurntoLight: T2d:  TurntoDark: Wl: Wd:
'Bambino-21  Creaton of sections ACTIONS, BEHAVIOURS, ACTS;
'            Introduction of ACT parameter 'Ado'
'Bambino-22  Demo routine + example use of Start1: to flash eyes
'Bambino-23  Walk Fd with obstacles avoidance using eyes from 04,
'            introduction of Default behaviour
'Bambino-24  Walk Fd with obstacles avoidance as 23, with Act BT
'Bambino-25  Walk Fd with drop-off avoidance using whiskers from 05
'            obstacle map extended to include holes

'-----------------------------------------------------------------
Rationale:
'Walk Fd with drop-off avoidance using whiskers from 05
'------------------------------------------------------
'As we saw in #05, Bambino can detect the edges of a table.
'program #24 is rewritten so Bambino avoids table edges.
'As with most sensors the results are not perfect and sometimes
'it will be obvious to a human that there is a table edge just 
'in front of Bambino but which Bambino fails to see.
'If you have ever stepped of a curb and twisted your ankle you 
'will know that human sensors are not infallible either!
'The obstacle map has been extended with two extra bits for holes.
'=================================================================
'modified
'--------
'B0,B1,B2 changed round
'obstacles - top two bits hole map, bottom two obstacle map
'whiskerLedX_  renamed GwhiskerLedX_ for Ground Whisker
'EyesOFF: renamed LedsOFF   and now turns off GwhiskerLeds
'EyesON: renamed ELedsON

'New
'---
'holedetectL
'holedetectR
'QGwhiskerL:    Query Ground whisker Left
'QGwhiskerR:    Query Ground whisker Right
'Glight       =B20 'ambient light from ground
'=================================================================

SYMBOL servopace    =c.0  'left connector
SYMBOL servoroll    =c.4  'right connector
SYMBOL VoiceLed_    =c.5  'low =>LED on
SYMBOL eyeLedL_     =c.2  'low =>LED on
SYMBOL eyeLedR_     =b.1  'low =>LED on
SYMBOL GwhiskerLedL_=c.3  'low =>Ground whisker LED on
SYMBOL GwhiskerLedR_=b.3  'low =>Ground whisker LED on
SYMBOL eyeR         =c.7  'adc
SYMBOL eyeL         =c.1  'adc
SYMBOL GwhiskerL    =b.5  'adc Ground whisker Down Left
SYMBOL GwhiskerR    =b.0  'adc Ground whisker Down Right
SYMBOL inIR         =c.6
SYMBOL outIR        =b.2

SYMBOL tempW0     =W0
SYMBOL  temp0       =B0   'initialise
'SYMBOL t0eyelit     =B0
SYMBOL whisklit     =B1   'QGwhiskerX
'SYMBOL tempW1     =W1
SYMBOL cmnd         =B2
SYMBOL B_flags      =B3
SYMBOL  f_Bfast      =bit31 'speed Behaviour 1=use B_fast:
SYMBOL Scentre    =W2
SYMBOL  rollC       =B4  '100 is roll to the left, 200 to the right
SYMBOL  paceC       =B5  '100 is left foot back, 200 left foot forward
SYMBOL Sat        =W3    'current servo positions
SYMBOL  rollat      =B6
SYMBOL  paceat      =B7
SYMBOL Sto        =W4    'desired servo positions
SYMBOL  rollto      =B8
SYMBOL  paceto      =B9
SYMBOL Sspeed     =W5
SYMBOL  rollspeed   =B11 '4 is too fast, 0 won't move
SYMBOL  pacespeed   =B12 '6 is about max for servos to keep up
SYMBOL i            =B13 '_iStand: Acts:
SYMBOL spulse       =B14 'FOR NEXT counter for servo pulses
'SYMBOL eyeRval      =B15
SYMBOL lightL       =B15 'light level Left
'SYMBOL eyeLval      =B16
SYMBOL lightR       =B16 'light level Right
SYMBOL eyediff      =B17
SYMBOL Ado          =B18 'parameter for Acts
SYMBOL obstacles    =B19 '%1111 bitmap of obstacles
                         '%Lefthole,Righthole,Leftobstacle,Rightobstacle,
SYMBOL Glight       =B20 'ambient light from ground

'=== Your Bambino ================
SYMBOL rollby     =15  '15 good for walking, edit to value in program11
SYMBOL paceby     =25  '+ve Left foot forward 20@speed 3; 25@speed 1
SYMBOL sframe     =20  'time between servo pulses
SYMBOL rollbymax  =20  '@speed 3; 25@speed 1
'rollmax absolute max is 40, above that the tilt rods hit the body
SYMBOL pacebymax  =30
'pacebymax absolute max is 30, above that the tilt rods hit the rear femur 
'and the horn screws hit the leg body

'EEPROM DATA
SYMBOL DrollC =254  'holds rollC, 100 is roll to the left, 150 is nominal centre
SYMBOL DpaceC =255  'holds paceC, 100 is left foot back,   150 is nominal centre
'=================================

  'depending on the sensors obsdetectL and obsdetectR may need to be different
SYMBOL obsdetectL   =10  '% light level difference for obstacles
SYMBOL obsdetectR   =10  '% light level difference for obstacles
  'depending on the sensors holedetectL and holedetectR may need to be different
  'If there is close tungsten light then Bambino may need an eye shade or a neb to shield the ground from the tungsten light.
SYMBOL holedetectL=2  'light level difference for holes
SYMBOL holedetectR=2  'light level difference for holes
'edit holedetect values so Bambino can see table edges
'whisker LEDs on, 82R 1.414v =>17.2mA @4.02V

'=================================================================
initialise:
  'get values from EEPROM set by program #8 or #8+
  READ DrollC,rollC
  READ DpaceC,paceC
  SERTXD("rollC=",#rollC," paceC=",#paceC,CR)

  LOW eyeLedR_     'make output
  HIGH eyeLedL_    'make output
  GOSUB _iStand    'stand and initialise rollat, paceat

initspeed:
  GOSUB B_fast
  
  
START:
SERTXD(CR,"S")

  obstacles =0
  GOSUB LedsOFF

QGwhiskerL:
  READADC GwhiskerL,Glight 'ambient light
  LOW GwhiskerLedL_        'eyeL on
  PAUSE 1
  READADC GwhiskerL,whisklit
  HIGH GwhiskerLedL_       'eyeL off
  whisklit =whisklit MIN Glight 'shouldn't be darker with LED on
  whisklit =whisklit -Glight
  SERTXD(" L=",#Glight,"/",#whisklit," ")
  IF whisklit>holedetectL THEN QGwhiskerR  'ignore - not a hole
  obstacles =obstacles OR %1000

QGwhiskerR:
  READADC GwhiskerR,Glight 'ambient light
  LOW GwhiskerLedR_        'eyeR on
  PAUSE 1
  READADC GwhiskerR,whisklit
  HIGH  GwhiskerLedR_      'eyeR off
  whisklit =whisklit MIN Glight 'shouldn't be darker with LED on
  whisklit =whisklit -Glight
  SERTXD("R=",#Glight,"/",#whisklit)
  IF whisklit>holedetectR THEN Walk    'ignore - not a hole
  obstacles =obstacles OR %0100


Walk:
  HIGH eyeLedR_      'eye OFF
  HIGH eyeLedL_      'eye OFF
  temp0 =obstacles   'to use bits
  IF BIT2=1 THEN
    LOW GwhiskerLedR_
   ENDIF
  IF BIT3=1 THEN
    LOW GwhiskerLedL_
   ENDIF
  SERTXD(cr," map",#bit3,#bit2,#bit1,#bit0)
  'combine holes and obstacles
  bit1 =bit3 OR bit1
  bit0 =bit2 OR bit0
  obstacles =temp0 AND %11  'delete top two bits  
  SERTXD(" ",#bit1,#bit0)
  ON obstacles GOSUB Fd,Lt,Rt,BT
  GOTO START                    'loop back to start


'-----------------------------------------
'Acts
'----

RockAdo:
  FOR i=1 TO Ado
    GOSUB _rollR
    GOSUB _rollL
   NEXT i
  RETURN

FdAdo:
  FOR i=1 TO Ado
    GOSUB Fd
   NEXT i
  RETURN

BkAdo:
  FOR i=1 TO Ado
    GOSUB Bk
   NEXT i
  RETURN

BT:
  GOSUB Bk
  GOSUB Bk
  GOSUB Rt
  GOSUB Rt
  RETURN

'-----------------------------------------
'Behaviours
'----------
B_fast:
  pacespeed  =6    '6 is about max for servos to keep up
  rollspeed  =3    'half of pacespeed is about right for walking
  f_Bfast =1
  RETURN
'B_medium:
'  rollspeed =2
'  pacespeed =3
'  RETURN
'B_slow:
'  rollspeed =1
'  pacespeed =2
'  RETURN
B_turn:
  rollspeed =1  'slow so foot doesn't bounce
  pacespeed =5
  RETURN
'-----------------------------------------
'Actions
'-------

beep150:
  sound VoiceLed_,(150,10)
  RETURN

LedsOFF:
  HIGH eyeLedR_
  HIGH eyeLedL_
  HIGH GwhiskerLedR_
  HIGH GwhiskerLedL_
  RETURN

ELedsON:
  LOW eyeLedR_
  LOW eyeLedL_
  RETURN


Fd:
  SERTXD (" Fd")
  IF f_Bfast=1 THEN GOSUB B_fast
  IF paceat<paceC THEN _FdL 'else _FdL
_FdR:
'SERTXD ("_FdR")
  GOSUB _rollL
  GOSUB _RF
  GOSUB Stand
  RETURN
_FdL:
'SERTXD ("_FdL")
  GOSUB _rollR
  GOSUB _LF
  GOSUB Stand
  RETURN


Bk:
  SERTXD (" Bk")
  IF f_Bfast=1 THEN GOSUB B_fast
  IF paceat<paceC THEN _BkR 'else _BkL
_BkL:
  GOSUB _rollR
  GOSUB _RF
  GOSUB Stand
  RETURN
_BkR:
  GOSUB _rollL
  GOSUB _LF
  GOSUB Stand
  RETURN


Rt:
  SERTXD (" Rt")
  IF paceat<paceC THEN GOSUB Fd  'need left foot forward
  IF f_Bfast=1 THEN GOSUB beep150
  IF f_Bfast=1 THEN GOSUB B_turn
  GOSUB _RF
  RETURN

Lt:
  SERTXD (" Lt")
  IF paceat>paceC THEN GOSUB Fd  'need right foot forward
  IF f_Bfast=1 THEN GOSUB beep150
  IF f_Bfast=1 THEN GOSUB B_turn
  GOSUB _LF
  RETURN

_RF:
'SERTXD ("_RF")
  paceto =paceC -paceby
  FOR spulse=paceat TO paceto STEP -pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_LF:
'SERTXD ("_LF")
  paceto =paceC +paceby
  FOR spulse=paceat TO paceto STEP pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN


Stand:  'stand with both feet flat
'SERTXD (" Sd")
  IF rollat<rollC THEN _StandR 'else _StandL
_StandL:
'SERTXD ("_SL")
  FOR spulse=rollat TO rollC STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_StandR:
'SERTXD ("_SR")
  FOR spulse=rollat TO rollC STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN


_rollL:
'SERTXD ("_rL")
  rollto =rollC -rollby
  FOR spulse=rollat TO rollto STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN

_rollR:
'SERTXD ("_rR")
  rollto =rollC +rollby
  FOR Spulse=rollat TO rollto STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN

_iStand:
'initialise with feet in mid position
  FOR i=0 TO 10
    PULSOUT servopace,paceC  'pulse servo paceC
    PULSOUT servoroll,rollC  'pulse servo rollC
    PAUSE 70        'pause 70ms - do it slowly
   NEXT i
  rollat =rollC
  paceat =paceC
  RETURN

pulseservos:
  PULSOUT servoroll,rollat  'pulse servo
  PULSOUT servopace,paceat  'pulse servo
  PAUSE sframe
  RETURN
'=================================================================
