Bambino_41:
SERTXD("B41",CR)    'report program number @4800

'1998 bytes

#PicAxe 20M2
#no_data

'Choose #defines
'#define SRF05       'use a PicAxe SRF05 ultrasonic sensor
                    'if no echo SRF05 times out at 32ms
#define HCSR04      'use a HC-SR04 ultrasonic sensor    
                    'if no echo HC-SR04 never times out
#define centimeters 'distances in centimeters cm
'#define inches      'distances in inches 
                    '(takes two extra bytes over distance in cm)
'#define testUS
'=================================================================
'PICAXE            IC   Memory   ext  I/O   Outputs  Inputs  ADC  Memory                        Starts  Polled  Resonator
'    Type        pins  bytes    slot pins                        Vars. RAM Spad Data     Table*        Int.    def. opt.
'2.28 PICAXE-20M2  20    2k           18    1-16     1-17     4    28   512      256      512   8       Yes      4   -32

'PICAXE-20M2 circuit board with LEDs off takes 1mA
'PICAXE-20M2 circuit board with LEDs off and servos connected takes 10mA
'=================================================================

Bambino_Suite:
'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values
'Bambino-06  Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-07  Set servos to mid position
'Bambino-08  Calibrate servo mid positions and put in EEPROM.
'Bambino-08+ Adjust servo mid positions from Handset and put in EEPROM.
'Bambino-09  Introduce _iStand:- initialise with feet in mid position
'Bambino-10  Set rollby, rollbymax for Roll Right
'Bambino-11  Check rollby, rollbymax for Roll Left
'Bambino-12  Check rollby and rollbymax for rollL, rollR
'Bambino-13  Introduction of _Stand
'Bambino-14  Investigate effect of rollspeed;
'            watch roll for all three speeds
'Bambino-15  Investigate effect of rollspeed;
'            watch Roll and Stand for all three speeds
'Bambino-16  Check paceFL paceFR;  Investigate effect of pacespeed
'            Introduction of pulseservos:
'Bambino-17  Check Fd
'Bambino-18  Test Rt, Lt
'Bambino-19  Test Bk
'Bambino-20  Test T2l: TurntoLight: T2d:  TurntoDark: Wl: Wd:
'Bambino-21  Creaton of sections ACTIONS, BEHAVIOURS, ACTS;
'            Introduction of ACT parameter 'Ado'
'Bambino-22  Demo routine + example use of Start1: to flash eyes
'Bambino-23  Walk Fd with obstacles avoidance using eyes from 04,
'            introduction of Default behaviour
'Bambino-24  Walk Fd with obstacles avoidance as 23, with Act BT
'Bambino-25  Walk Fd with drop-off avoidance using whiskers from 05
'Bambino-26  rewritten with reading of whiskers as subroutines
'Bambino-27  rewritten with autocalibration of down whiskers
'Bambino-28  Test maximum PWM and hence minimum brightness of eyeLEDs,
'            needed in Bambino-29
'Bambino-29  Wait for IR command then do it otherwise WANDER as B24
'Bambino-30  rewrite to clearer code
'Bambino-31  remember a sequence of key presses on IR-controller
'Bambino-32  remember up to 7 sequences of key presses in RAM, 
'            forgotten on power off
'Bambino-33  remember up to 8 sequence of key presses in EEPROM,
'            now not forgotten.
'            Data can now be sent to a PC.
'Bambino-34  obstacles memory made deeper for better obstacle avoidance,
'            and put in RAM, Mfrus_obs introduced
'Bambino-35  key [0] can now be learned
'Bambino-36  incorporate drop-off avoidance from B25,
'            remember holes and obstacles   
'Bambino-37  PicAxe SRF05 Ultrasonic sensor added
'            and facility to adjust
'            USawareAt and UStoonear from IR-handset  
'Bambino-38  Added code to use either PicAxe SRF05 or an HC-SR04 
'            Ultrasonic sensor with #defines for sensor type,
'            cm or inches, and testUS.  
'Bambino-39  added KEY_PLUS to Test Ping sensor and act on result,
'            can be put in learned routines.
'            added poweron test of US, if <10 then disable US
'Bambino-40  revised use of LEDs for indicating holes/obstacles
'            Separated Whisker and Ultrasonic actions in Walk:
'Bambino-41  added CASE KEY_9 '[9] Behaviour to select behaviours
'            B_slow,B_medium,B_fast,
'            B_UStimid,B_USnormal,B_USbold,
'            B_noWhiskers,B_noUS
'            B_USxxx now write to RAM
'-----------------------------------------------------------------
Rationale:
'Being able to have Bambino walk at different speeds and to react to 
'obstacles at different distance adds to what it can do.
'Also if you think that the lights are affecting the optical sensors 
'or low batery is affecting the Ultrasonic sensor then they can be 
'disabled with KEY_9 mode.
'See the sections BambinoCommands: and TVR010_PicAxe_IR_controller:.
'Now the USdistances are in RAM any values saved using the handset are
'not overwritten when USbold, USnormal, or UStimid are used so if
'necessary the EEPROM is initialised with DUStoonear, DUSawareat, 
'DUSconfigOK in in INITIALISE:.
'=================================================================
Modified_and_New:
'modified
'--------
'SERTXD "IR" when waiting for IRcmnd cahnged to "k" for key, more readable
''[+] do Pingsensor     CASE KEY_PLUS  
'B_USbold:,B_USnormal:,B_UStimid: now alter RAMUS
'R_Ping: now uses distnce settings in RAM
'INITIALISE: user US settings in EEPROM now copied to RAM
'
'New
'---
'SYMBOL B_USnormaltoonear =10
'SYMBOL B_USnormalawareat =20
'SYMBOL RAMUStoonear   =36   so B_US does not alter user setting
'SYMBOL RAMUSawareAt   =37   so B_US does not alter user setting
'f_dowhiskers
'BeHave  B20
'CASE KEY_9 'Behaviour
''do Behaviours   CASE >199
'B_slow,B_fast,B_UStimid,B_USbold,B_noWhiskers,B_noUS
'
'=================================================================
ProgramOverview:
'Bambino_Suite:
'Modified_and_New:
'ProgramOverview:
'BambinoCommands:
'TVR010_PicAxe_IR_controller:
'PIN_MAPPING:
'VARIABLES_and_CONSTANTS:
'Movement commands
'EEPROM Acts, start addresses
'EEPROM config data addresses
'RAM data addresses
'PingSensors:
'------------------------------------------
'INITIALISE:         initialise Bambino
'init_rollCpaceC:
'initMIND:
'initBODY:
'GOTO Qwander and listen for IR cmnd(with timeout)
'    if cmnd then NewCmnd else WANDER:
'------------------------------------------
'ACTIVITIES:

'NewCmnd:
'Docmnd:
'  select action on cmnd
'    includes all cmnds listed under [KEY_xxx]
'    Play and Record set playing and recording flags
'    some actions alter cmnd and goto Docmnd to reprocess cmnd
'    key Acts: could just drop through to IRcmnd but does a goto instead,
'      saves testing the Play and Record flags
'
'RecordAct:
'    if recording then
'        if end of slot
'            cmnd=end
'            goto Docmnd to execute it
'        write cmnd to selected act in eeprom
'
'PlayAct:
'    if playing then
'        read cmnd of selected act from eeprom
'        if cmnd <> end of list
'            goto Docmnd to execute it
'        else drop through to IRcmnd:
'
'IRcmnd:
'    wait for IR cmnd
'    beep to acknowlede IR
'    goto Docmnd
'
'------------------------------------------
'[initMIND:               ]
'[  calibrate hole sensors]
'WANDER:
'  DecayMemory:         decay obstacle map in memory
'  Qholes:              Query holes - read Gwhiskers
'                       set LEDs so we knw what is happening
'  Qobstacles           Query obstacles - read Ewhiskers
'                       set LEDs so we knw what is happening
'  MemoryShowObstacles: read memory
'  MapBuild:            
'  Walk:                act on cmnd - Fd,Lt,Rt,Bk2
'                       test US and act on usdist - R_Ping: 
'  Qwander              listen for IRcmnd(with timeout)
'                       if no cmnd  goto WANDER
'                       if cmnd goto NewCmnd:     (and then Docmnd),
'=================================================================
'BEHAVIOURS:
'B_fast:
'B_medium:
'B_slow:
'B_turn
'B_USbold:
'B_USnormal:
'B_UStimid:
'=================================================================
'REACTIONS:
'R_Ping:
'=================================================================
'PROGRAM_ACTS:
'RockAdo:  '#128
'FdAdo:
'BkAdo:
'Rest:
'_RestIRin:
'=================================================================
'ACTIONS:
'Fd:
'_FdR:
'_FdL:
'-----------------------------------------
'Bk:
'_BkL:
'_BkR:
'-----------------------------------------
'Rt:
'-----------------------------------------
'Lt:
'-----------------------------------------
'Stand:  'stand with both feet flat
'_StandL:
'_StandR:
'=================================================================
'MOVEMENTS:
'_RF:
'_LF:
'-----------------------------------------
'_rollL:
'_rollR:
'-----------------------------------------
'pulseservos:
'-----------------------------------------
'_iStand:
'=================================================================
'COMMUNICATION:  'HMI - Human Machine Interface
'beep50:
'beep255:
'EyesOFF:
'EyesON:
'EyesDimmest:
'=================================================================
'UTILITIES:
'IRgetAct_cmnd:
'nokey:
'badkey:
'=================================================================
'SENSE:
'QEwhiskerL:
'QEwhiskerR:
'calibrateholewhiskers:
'QGwhiskerL:
'QGwhiskerR
'setUSawares:
'QPing:
'=================================================================
BambinoCommands: 'using TVR010_PicAxe_IR_controller
'
'[KEY_POWER] stops a learned Act and enters Command mode.
'            ends modify mode, ends learning
'            it can't stop a subroutine Act
'
'Direction Keys
'--------------
'[KEY_UP]    ie [Fd] Step Forward
'[KEY_DOWN]  ie [Bk] Step Backward
'[KEY_RIGHT] ie [Rt] Step Right
'[KEY_LEFT]  ie [Lt] Step Left
'
'Function Keys
'-------------
'[KEY_BAR]    ie [f|] enters learn mode to record key presses
'                     has to be followed by a number key 1-8
'                     = the Act to be remembered
'                     up to 8 Acts can be learned
'                     learned Acts can call subroutine Acts
'Acts can chain to other Acts, eg Fd,Bk,2   - chain to Act2
'A learned Act which chains itself repeats forever, 
'eg [f|][1][Fd][1][POWER]  Act1 will do Fd forever

'[KEY_TENT]   ie [f^] selects subroutine Acts = SAct,
'                     has to be followed by a number key 1-8
'                     plays SActs, SActs play until the end.
'                     [KEY_1]=>RockAdo
'[KEY_VCROSS] ie [f+] modify USawareAt, UStoonear
'                     [+] set USAwareAt in EEPROM DUSawareAt
'                     [-] set UStoonear in EEPROM DUStoonear
'                     [Key_POWER] to quit
'[KEY_XCROSS] ie [fX] Dump EEPROM Acts DATA to PC, including Config Data
'
'Act Keys
'--------
'[1] to [8] Play an Act
'[f^][1] to [f^][8] Play a subroutine Act
'When Recording an Act,
'  [1]-[8] record a jump to a new Act
'    if [1],[2],[3],[4],[5],[6],[7].[8],[0] are used to jump to 
'    another Act there is no point in recording more moves because they
'    will never be replayed since control is transfered to the new Act,
'    just press [KEY_POWER] to end the recording;
'  [f^] then [1]-[8] to do and include a Subroutine Act (SAct);
'  when the memory slot is full Bambino will beep and recording will end.
'Act8 Autoruns on PowerOn
'  On poweron to WANDER              do [f|][8][0][Power]   
'                enter command mode  do [f|][8][Power]   
'                WANDER B_slow       do [f|][8][9][1][0][Power]
'                run Act1            do [f|][8][1][Power]
'                do SAct1 then Act1  do [f|][8][f^][1][1][Power]
'                etc 
'Act0 is WANDER and cannot be changed
'
'Behavior Key
'------------
'[9] Behaviour mode  eg [9][1] set speed slow 
'  [1] set speed slow 
'  [2] set speed medium 
'  [3] set speed fast 
'  [4] set US behaviour to timid
'  [5] set US behaviour to normal
'  [6] set US behaviour to bold
'  [7] disable Whiskers test
'  [8] disable Ultrasonic test
'
'Sensor Keys
'-----------
'[+] enable and test Ping sensor and re-act, R_Ping:
'
'Activity Key
'------------
'[0] WANDER
'
'
'Quirks
'------
'  If you are recoeding Act1 and press [f|][2] then you will start 
'to record Act2 and Act1 will be left without placing an end marker. 
'If Act1 is then played the new moves will be played then whatever 
'moves remained there from before.
'=================================================================
TVR010_PicAxe_IR_controller:
'---------------------------
'Before use, the transmitter must be programmed with the Sony transmit code.
'1. Insert 2 AAA size batteries, preferably alkaline.
'2. Press S and B at the same time. S is in the centre of the arrows.
'  The top left red LED should light.
'3. Press 0. The LED should flash.
'4. Press 1. The LED should flash.
'5. Press 3. The LED should go out.
'6. Press the red power button (top right).
'-------------------------------------------
'IRin cmnds PicAxe controller
'DO NOT PRESS KEYS [A] [B] [C] [D] [E] [F] [G]
'They change the Mode and [B] has to be pressed to change back.
'[square] [triangle] [()] [L] [X] [backwards F]  have no effect
'keys [f|],[f^],[f+],[fX] are the function keys above the number keys

SYMBOL KEY_POWER  = 21    'Sleep

SYMBOL KEY_UP     = 16    '[Fd] Step Forward
SYMBOL KEY_DOWN   = 17    '[Bk] Step Backward
SYMBOL KEY_RIGHT  = 18    '[Rt] Step Right
SYMBOL KEY_LEFT   = 19    '[Lt] Step Left

SYMBOL KEY_BAR    = 96    '[f|] learn an Act, next [key] selects an Act
SYMBOL KEY_TENT   = 54    '[f^] next [key] selects a Subroutine-Act
SYMBOL KEY_VERT_CROSS = 37  'use synonym for easier coding
SYMBOL KEY_VCROSS = 37    '[f+] Modify Mode {when routine included}
                          '     [+] set USAwareAt in DUSawareAt
                          '     [-] set UStoonear in DUStoonear
                          '    {[Fd] alter PaceCentre in DpaceC}
                          '    {[Bk] alter PaceCentre in DpaceC}
                          '    {[Rt] alter RollCentre in DrollC}
                          '    {[Lt] alter RollCentre in DrollC}
                          '    {     [-][+]  to adjust         }
                          '     [Key_POWER] to quit
SYMBOL KEY_DIAG_CROSS = 20  'use synonym for easier coding
SYMBOL KEY_XCROSS = 20    '[fX] transfer EEPROM to PC for including in programs
                          '    -- Subroutine-Act and Commands --
SYMBOL KEY_1      =  0    '[1] [f^][1]=>RockADo      [9][1]=set speed slow 
SYMBOL KEY_2      =  1    '[2]                       [9][2]=set speed medium 
SYMBOL KEY_3      =  2    '[3]                       [9][3]=set speed fast 
SYMBOL KEY_4      =  3    '[4]                       [9][4]=set US behaviour to timid
SYMBOL KEY_5      =  4    '[5]'                      [9][5]=set US behaviour to normal
SYMBOL KEY_6      =  5    '[6]'                      [9][6]=set US behaviour to bold
SYMBOL KEY_7      =  6    '[7]'                      [9][7]=disable Whiskers test
SYMBOL KEY_8      =  7    '[8]'                      [9][8]=disable Ultrasonic test
SYMBOL KEY_9      =  8    '[9] [1]-[8] set Behaviour modes
SYMBOL KEY_MINUS  = 98    '[-]
SYMBOL KEY_0      =  9    '[0] QUIT command mode
SYMBOL KEY_PLUS   = 11    '[+] enable & test Ping sensor and re-act, R_Ping:
'=================================================================
PIN_MAPPING:

'SYMBOL whiskerR     =b.0  'adc whisker Down Right
'SYMBOL eyeLedR_     =b.1  'low =>LED on
'SYMBOL outIR        =b.2
'SYMBOL whiskerLedR_ =b.3  'low =>whisker LED on
'b.4
'SYMBOL GwhiskerL    =b.5  'adc whisker Down Left
'b.6
'SYMBOL pingpin      =b.7  'Ultrasonic sensor SRF05 in single pin mode
                           ' or HC-SR04 on a single pin 
'SYMBOL servopace    =c.0  'left connector
'SYMBOL eyeL         =c.1
'SYMBOL eyeLedL_     =c.2  'low =>LED on
'SYMBOL GwhiskerLedL_=c.3  'low =>whisker LED on
'SYMBOL servoroll    =c.4  'right connector
'SYMBOL VoiceLed_    =c.5  'low =>LED on
'SYMBOL inIR         =c.6
'SYMBOL eyeR         =c.7

SYMBOL servopace    =c.0  'left connector
SYMBOL servoroll    =c.4  'right connector
SYMBOL VoiceLed_    =c.5  'low =>LED on
SYMBOL eyeLedL_     =c.2  'low =>LED on
SYMBOL eyeLedR_     =b.1  'low =>LED on
SYMBOL whiskerLedL_ =c.3  'low =>whisker LED on
SYMBOL whiskerLedR_ =b.3  'low =>whisker LED on
SYMBOL eyeR         =c.7  'adc
SYMBOL eyeL         =c.1  'adc
SYMBOL whiskerL     =b.5  'adc whisker Down Left
SYMBOL whiskerR     =b.0  'adc whisker Down Right
SYMBOL inIR         =c.6
SYMBOL outIR        =b.2
SYMBOL pingpin      =b.7  'Ultrasonic sensor SRF05 in single pin mode 
                          ' or HC-SR04 on a single pin 
'-----------------------------------------
VARIABLES_and_CONSTANTS:

SYMBOL OK =224            'arbitrary value

SYMBOL tempW0     =W0
SYMBOL  temp0       =B0   'initialise: walk:
SYMBOL  tempLo      =B0
SYMBOL  eyelit      =B0   'QEwhiskerX
SYMBOL  whisklit    =B0   'QGwhiskerX
SYMBOL  temp1       =B1
SYMBOL  tempHi      =B1
'SYMBOL tempW1     =W1
SYMBOL M_flags      =B2    'Mind flags
SYMBOL  f_mapR       =bit22 'obstacle/hole map R 
SYMBOL  f_mapL       =bit23 'obstacle/hole map L
SYMBOL B_flags      =B3     'Behaviour flags
SYMBOL  f_dowhiskers =bit24 '0=ignore Eye and Ground Whiskers
SYMBOL  f_doUS       =bit25 '0=ignore US
SYMBOL  f_memturn    =bit26 '1=turned Left, 0= turned Right
'SYMBOL  f_hole       =bit27 '1=a hole   
SYMBOL  f_play       =bit28 '1=playing
SYMBOL  f_record     =bit29 '1=recording
SYMBOL  f_direction  =bit30 'currrent direction Fd=1, Bk=0
SYMBOL  f_Bfast      =bit31 'speed Behaviour 1=use B_fast:
SYMBOL Scentre    =W2
SYMBOL  rollC       =B4  '100 is roll to the left, 200 to the right
SYMBOL  paceC       =B5  '100 is left foot back, 200 left foot forward
SYMBOL Sat        =W3    'current servo positions
SYMBOL  rollat      =B6
SYMBOL  paceat      =B7
SYMBOL Sto        =W4    'desired servo positions
SYMBOL  rollto      =B8
SYMBOL  paceto      =B9
SYMBOL Sspeed     =W5
SYMBOL  rollspeed   =B10 '4 is too fast, 0 won't move
SYMBOL  pacespeed   =B11 '6 is about max for servos to keep up
'SYMBOL Smoveby    =W6
'SYMBOL  rollby      =B12 '+ve right 15 good for walking
'SYMBOL  paceby      =B13 '+ve Left foot forward 20@speed 3; 25@speed 1
SYMBOL Light      =W7
SYMBOL  lightR      =B14 'light level Right
SYMBOL  lightL      =B15 'light level Left
SYMBOL counters   =W8
SYMBOL  i           =B16 '_iStand:
SYMBOL  spulse      =B16 'FOR NEXT counter for servo pulses
SYMBOL  iA          =B17 'counter for Acts
'W9
SYMBOL Ado          =B18 'parameter for Acts
SYMBOL bitmap_obs   =B19 '%11 bitmap of obstacles  %LeftRight    
'w10
SYMBOL Act          =B20
SYMBOL BeHave       =B20
SYMBOL Apend        =B21 'Penultimate end of record slot
'w11
SYMBOL eptr         =B22  'pointer to EEPROM
SYMBOL usdist       =B23  'US distance to object   
SYMBOL cmnd         =B24
SYMBOL IRcmnd       =B24  'cmnd from IRremote
'b25 - b27

'=== Your Bambino ================
SYMBOL rollby     =15  '15 good for walking, edit to value in program11
SYMBOL paceby     =25  '+ve Left foot forward 20@speed 3; 25@speed 1
SYMBOL sframe     =20  'time between servo pulses
SYMBOL rollbymax  =20  '@speed 3; 25@speed 1
'rollmax absolute max is 40, above that the tilt rods hit the body
SYMBOL pacebymax  =30
'pacebymax absolute max is 30, above that the tilt rods hit the rear femur 
'and the horn screws hit the leg body

SYMBOL slot7E     =250  'slot 7 End, don't overwrite Config Data
'EEPROM Config DATA addresses
SYMBOL DUSconfigOK=251  '224=ok
SYMBOL DUStoonear =252  'holds UStoonear, Bk if usdist <= UStoonear
SYMBOL DUSawareAt =253  'holds USawareAt, noaction if usdist>USawareAt
SYMBOL DrollC     =254  'holds rollC, 100 is roll to the left, 150 is nominal centre
SYMBOL DpaceC     =255  'holds paceC, 100 is left foot back,   150 is nominal centre
'=================================

  'depending on the sensors obsclearL and obsclearR may need to be different
SYMBOL obsclearL    =20 '% light level difference > for obstacle
SYMBOL obsclearR    =20 '% light level difference > for obstacle
  'depending on the sensors holedetectL and holedetectR may need to be different
  'If there is close artificial light then Bambino may need an eye shade or a neb to shield the ground from the artificial light.
SYMBOL holedetectL  =2  'light level difference for holes
SYMBOL holedetectR  =2  'light level difference for holes
  'edit holedetect values so Bambino can see table edges
  'whisker LEDs on, 82R 1.414v =>17.2mA @4.02V
SYMBOL Minc_obs     =2  'Mind increment  for obstacle
SYMBOL Mmax_obs     =4  'Mind limit to obstacle memory
SYMBOL Mfru_obs     =2  'Mind level above which back direction is selected for turns
SYMBOL Minc_hole    =4'6'8  'Mind memory increment  for holes
SYMBOL Mmax_holes   =6'8  'Mind max memory increment  for holes

SYMBOL B_USnormaltoonear =10
SYMBOL B_USnormalawareat =20
'-----------------------------------------
'EEPROM Acts, start addresses
SYMBOL act0s  =0     ' 0-31
SYMBOL act1s  =32    '32-63
SYMBOL act2s  =32 *2 '64-95
SYMBOL act3s  =32 *3 '96-127
SYMBOL act4s  =32 *4 '128-159
SYMBOL act5s  =32 *5 '160-191
SYMBOL act6s  =32 *6 '192-223
SYMBOL act7s  =32 *7 '224-250  - EEPROM config DATA 251,252,253,254,255

'If [KEY_XCROSS] is used to dump to a PC EEPROM Acts DATA from another Bambino
'then paste it here

'-----------------------------------------
'RAM data addresses
SYMBOL RAMholedetectR =32   'set by calibrateholewhiskers:
SYMBOL RAMholedetectL =33   'set by calibrateholewhiskers:
SYMBOL RAMobstaclesR  =34
SYMBOL RAMobstaclesL  =35
SYMBOL RAMUStoonear   =36
SYMBOL RAMUSawareAt   =37
'=================================================================
PingSensors:
'-----------
' At sea level sound travels through air at 1130 feet per second.
' This equates to 1 inch in 73.746 uS, or 1 cm in 29.034 uS.
'
' Since the Ping sensor measures the time required for the sound wave 
' to travel from the sensor and back. The result is divided by two to
' remove the return portion of the echo pulse, then multiplied by 10
' to convert PicAxe20M2 10uS resolution to uS.
' The final raw result is converted to cm.or inches
'   uS  * 10/2/73.746in =>  * 0.01356 => *  4443/65536  => **  4443
'   uS  * 10/2/29.034cm =>  * 0.03444 => * 11286/65536  => ** 11286
SYMBOL uS10tocm        =11286  ' 10 / 147.492 (with **)
'SYMBOL uS10toinch      =4443   ' 10 / 58.068 (with **)

SYMBOL uS10tocm4mHz    =11286   ' 10 / 147.492 (with **)
SYMBOL cmtoinch        =25802   ' /2.54 -> *25802 /65536 -> **25802
SYMBOL USoff           =10 'on PowerOn if >= then enable US

#ifdef SRF05
   SYMBOL USscalecm =uS10tocm4mHz    'pulsin units 10uS
   SYMBOL pingtrig  =2               '20uS @4Mhz
 #endif

'The HC-SR04 starts the return pulse too quickly for a PicAxe20m2 at 4Mhz 
'to detect the start of the pulse. It needs to run at least at 8MHz.
'Also if the sensor never gets a return echo from an obstacle the 
'return pulse never ends and the PULSIN timer has to overflow before 
'it returns a value. At 8MHz the timer resolution is 5us. The timer 
'is 16 bits which means each reading takes '65,536 * 5us =327680 
'which is about 1/3 of a second. This is a long time to wait between 
'steps and makes walking very slow.
'Increasing the clock speed to 32MHz means the timer resolution is 
'1.25us and it times out in 65536 *1.25us = 81920us or about 0.08 
'of a second which is much better.
'So SETFREQ m32 is used before triggering the sensor
#ifdef HCSR04
   SYMBOL USscalecm =uS10tocm4mHz /8 'pulsin units 1.25uS
   SYMBOL pingtrig  =12              '15uS @32Mhz
 #endif
'=================================================================
#ifdef testUS
   goto testping
  #endif

INITIALISE:

init_Servos_rollCpaceC:
  'get values from EEPROM set by program #8 or #8+
  READ DrollC,rollC
  READ DpaceC,paceC
  SERTXD("rollC=",#rollC," paceC=",#paceC,CR)

  'check if US distances have been set from handset, if not use B_USnormal:
  READ DUSconfigOK,temp0
  IF temp0=OK THEN
    'copy DUS settings to RAM
    READ DUStoonear,temp0
    READ DUSawareAt,temp1
    POKE RAMUStoonear,temp0
    POKE RAMUSawareAt,temp1
  ELSE              'This should only happen once
    GOSUB B_USnormal 'set RAMUS distances to B_USnormal
    WRITE DUStoonear,B_USnormaltoonear  'initialise EEPROM data
    WRITE DUSawareat,B_USnormalawareat  'initialise EEPROM data
    WRITE DUSconfigOK,OK
   ENDIF
  

initBODY:
  HIGH eyeLedR_    'make output and OFF
  HIGH eyeLedL_    'make output and OFF
  GOSUB _iStand    'stand and initialise rollat, paceat

  GOSUB Qping                   'Query Ultrasonic
  IF USdist<USoff THEN initMIND 'and don't enable US
    f_doUS =1                   'enable US, poweron default is 0
  
    GOSUB beep255   'so we know Bambino started with US, 
                    'leaves VoiceLED on
 
'----------------
initMIND:
  GOSUB B_fast
  f_record =0
  Ado =4        'for RockAdo
  'RAMobstaclesL, RAMobstaclesR    always 0 on poweron
  GOSUB calibrateGwhiskers
  

  GOTO Qwander
'=================================================================
ACTIVITIES:

NewCmnd:
  GOSUB beep50            'so we know IR received

DoCmnd:
SERTXD(CR,#cmnd," @",#eptr)

  SELECT cmnd
  
'[POWER],[UP],[DOWN],[RIGHT],[LEFT],[0]
    CASE KEY_POWER
      IF f_record=0 AND f_play=0 THEN
        GOSUB rest
        GOTO NewCmnd      'have already got IRcmnd in rest:
       ELSE
        f_play =0
        IF f_record=1 THEN
          f_record =0
          WRITE eptr,255   'end marker
         ENDIF
        'GOSUB dump        'debug
       ENDIF
    CASE KEY_UP
      GOSUB Fd
    CASE KEY_DOWN
      GOSUB Bk
    CASE KEY_RIGHT
      GOSUB Rt
    CASE KEY_LEFT
      GOSUB Lt
    CASE KEY_0
      IF f_record=0 THEN initmind   'ignore [0] if recording
                                    'so it can be learned at recordAct:

'[1]-[8] Acts
    CASE <KEY_9            'keys [1]-[8] => cmnd 0-7 Acts 1-8
      IF f_record<>1 THEN
        f_play=1           'play
        eptr =32 *cmnd     'set to start
SERTXD("p@",#eptr,CR)
      ENDIF

'[9] Behaviour
    CASE KEY_9
      GOSUB IRgetKey1to8
      cmnd =cmnd +200
      GOTO DoCmnd          'already beeped

'[+] do Pingsensor
    CASE KEY_PLUS            'Test Ping sensor and act on result
      f_doUS =1
      GOSUB R_Ping 

'[mode|] record
    CASE KEY_BAR
      f_play =0
      F_record =1
      LOW VoiceLED_        'mouth lit for record
      GOSUB IRgetAct_cmnd
      eptr =32 *cmnd
      Apend =eptr +31 MAX slot7E 'to avoid overwriting EEPROM config DATA
      GOSUB nokey
SERTXD("r@",#eptr,CR)
      GOTO WaitIRcmnd      'get cmnds

'[mode^] subroutine Acts
    CASE KEY_TENT          'subroutine acts
      GOSUB IRgetAct_cmnd
      cmnd =cmnd +128      'set topbit for subroutine Acts
SERTXD(" A",#cmnd,CR)
      GOTO DoCmnd          'already beeped

'[mode+] Adjust
    CASE KEY_VCROSS        'modify USawareAt, UStoonear
_case_VCROSS:
      IRIN inIR,cmnd       'Get cmnd
      IF cmnd=KEY_PLUS OR cmnd=KEY_MINUS THEN
        GOSUB setUSawares
       ELSE 
        GOSUB badkey
       ENDIF 

'[modeX] Dump              'Remember internal Slots/Acts are 0-7 keys [1]-[8]
    CASE KEY_XCROSS        'Dump sends DATA to PC, include Config Data
      FOR Act=0 TO 7
        SERTXD(CR,"'Slot ",#Act,CR,"DATA ")
        FOR eptr=0 TO 30
          temp0 =Act *32 +eptr            
          READ temp0,cmnd
          SERTXD(#cmnd,",")
         NEXT eptr
        temp0 =Act *32 +31
        READ temp0,cmnd
        SERTXD(#cmnd)
       NEXT Act
      SERTXD(CR)

'do Behaviours
    CASE >199
      behave =cmnd -200
      '             [1]    [2]      [3]    [4]       [5]        [6]      [7]          [8]
      ON behave GOSUB B_slow,B_medium,B_fast,B_UStimid,B_USnormal,B_USbold,B_noWhiskers,B_noUS

'do subroutine Acts
    CASE >127
      Act =cmnd -128
SERTXD("C",#Act,CR)
      ON Act GOSUB RockAdo  'add others

    END SELECT
    
'-------------
recordAct:
  IF f_record=1 THEN
    IF eptr<Apend THEN
      WRITE eptr,cmnd
      eptr =eptr +1
     ELSE              'end of slot
      GOSUB beep255
      GOSUB beep255
      cmnd =KEY_POWER  'force end
      GOTO DoCmnd
     ENDIF
   ENDIF

playAct:
  IF f_play=1 THEN
    IRin [50,_playon],inIR,cmnd
    GOTO NewCmnd       'if IR REceived =>break
_playon:
    GOSUB EyesOFF
    READ eptr,cmnd
    Eptr =eptr +1
    IF cmnd<>255 THEN  DoCmnd  '255=end
    f_play =0
   ENDIF

WaitIRcmnd:
SERTXD("k")
  GOSUB EyesDimmest
  IF f_record=1 THEN
    LOW VoiceLED_
    GOSUB EyesOFF
   ENDIF                  'mouth lit
  IRIN inIR,cmnd          'Get cmnd
  GOTO NewCmnd

'-----------------------------------------
WANDER:
SERTXD(CR,"W")
  GOSUB EyesOFF
DecayMemory:
  PEEK RAMobstaclesR,tempLo  'read memory
  PEEK RAMobstaclesL,tempHi  'read memory
  tempLo =tempLo MIN 1 -1    'decay memory
  tempHi =tempHi MIN 1 -1    'decay memory
  POKE RAMobstaclesR,tempLo  'save
  POKE RAMobstaclesL,tempHi  'save
SERTXD (CR,"obL",#tempHi," obR",#tempLo,CR)

  f_mapR =0
  f_mapL =0

Qholes:
  GOSUB QGwhiskerL           'modify RAMobstaclesL
SERTXD("GwL=",#LightL,"/",#whisklit," ")
  GOSUB QGwhiskerR           'modify RAMobstaclesR
SERTXD(" GwR=",#LightR,"/",#whisklit,CR)
  IF f_mapL=1 THEN 
    LOW whiskerLedL_         'indicate hole
   ENDIF 
  IF f_mapR=1 THEN 
    LOW whiskerLedR_         'indicate hole
   ENDIF 
  IF f_mapL=1 OR f_mapR=1 THEN
    f_direction =0           'hole  so back turns
    GOTO MemoryShowObstacles 'skip Qobstacles if hole
   ENDIF 

Qobstacles:
  GOSUB QEwhiskerL           'modify RAMobstaclesL 
  GOSUB QEwhiskerR           'modify RAMobstaclesR
  IF f_mapL=1 THEN 
    LOW eyeLedL_             'indicate obstacle
   ENDIF 
  IF f_mapR=1 THEN 
    LOW eyeLedR_             'indicate obstacle
   ENDIF 
 
SERTXD("EwL%=",#lightL," EwR%=",#lightR,CR)
  
MemoryShowObstacles:
  PEEK RAMobstaclesR,tempLo  'read memory
  PEEK RAMobstaclesL,tempHi  'read memory
SERTXD ("obL",#tempHi," obR",#tempLo,CR)

Qfrustrated:                 'Query too many obstacles?
  tempHi =tempHi +tempLo
  IF tempHi>Mfru_obs THEN    'frustrated so back turns
    f_direction =0
   ENDIF
SERTXD("Omap",#bitmap_obs," ")

MapBuild:             'create short term memory bitmap
  bitmap_obs =f_mapL *2 +f_mapR
  
Walk: 
  '                 % 00 01 10 11
  ON bitmap_obs GOSUB Fd,Lt,Rt,Bk2
  GOSUB R_Ping
    
Qwander:
  irin [50,WANDER],inIR,cmnd  'irin with timeout, no IR =>WANDER
  GOTO NewCmnd                'QUIT if IRin

'=================================================================
BEHAVIOURS:
'----------
B_fast:
  pacespeed  =6    '6 is about max for servos to keep up
  rollspeed  =3    'half of pacespeed is about right for walking
  f_Bfast =1
  RETURN
B_medium:
  rollspeed =2
  pacespeed =3
  f_Bfast =0
  RETURN
B_slow:
  rollspeed =1
  pacespeed =1
  f_Bfast =0
  RETURN
B_turn:
  rollspeed =1  'slow so foot doesn't bounce
  pacespeed =5
  RETURN
B_USbold:
  POKE RAMUStoonear,5
  POKE RAMUSawareAt,10
  RETURN
B_USnormal:
  POKE RAMUStoonear,B_USnormaltoonear   '10
  POKE RAMUSawareAt,B_USnormalawareat   '20
  RETURN
B_UStimid:
  POKE RAMUStoonear,15
  POKE RAMUSawareAt,30  
  RETURN

B_noWhiskers:
  f_doWhiskers =0
  RETURN
B_noUS:
  f_doUS =0
  RETURN
'=================================================================
REACTIONS:
'---------
R_Ping:          'react to Ping information
  IF f_doUS=1 THEN
    GOSUB Qping             'read US -> usdist
    PEEK RAMUStoonear,temp0
    PEEK RAMUSawareAt,temp1
SERTXD("US",#usdist,"<=",#temp0,"|",#temp1)
    SELECT usdist
      CASE <=temp0
        GOSUB beep255
        GOSUB Bk2
      CASE <=temp1
        GOSUB beep50
        GOSUB Mt  'MemoryTurn, turn same way as last time
     ENDSELECT
   ENDIF   
  RETURN

'=================================================================
PROGRAM_ACTS:
'-----------

RockAdo:  '#128
  IF f_Bfast=1 THEN GOSUB B_fast
  FOR iA=1 TO Ado
    GOSUB _rollR
    GOSUB _rollL
   NEXT iA
  GOSUB Stand
  RETURN

FdAdo:
  FOR iA=1 TO Ado
    GOSUB Fd
   NEXT iA
  RETURN

BkAdo:
  FOR iA=1 TO Ado
    GOSUB Bk
   NEXT iA
  RETURN

Rest:
  GOSUB _rollL
  GOSUB _iStand
  GOSUB EyesDimmest
  HIGH whiskerLedL_
  HIGH whiskerLedR_
  HIGH VoiceLed_
_RestIRin:
  IRIN inIR,cmnd    'IRIN with no timeout
  RETURN

'=================================================================
ACTIONS:
'-------

Fd:
SERTXD ("F")
  f_direction =1
  IF f_Bfast=1 THEN GOSUB B_fast
  IF paceat<paceC THEN _FdL 'else _FdL
_FdR:
'SERTXD ("_FdR")
  GOSUB _rollL
  GOSUB _RF
  GOSUB Stand
  RETURN
_FdL:
'SERTXD ("_FdL")
  GOSUB _rollR
  GOSUB _LF
  GOSUB Stand
  RETURN
'-----------------------------------------
Bk2:
  GOSUB Bk
Bk:
SERTXD ("B")
  f_direction =0
  IF f_Bfast=1 THEN GOSUB B_fast
  IF paceat<paceC THEN _BkR 'else _BkL
_BkL:
  GOSUB _rollR
  GOSUB _RF
  GOSUB Stand
  RETURN
_BkR:
  GOSUB _rollL
  GOSUB _LF
  GOSUB Stand
  RETURN
'-----------------------------------------
Mt:  'MemoryTurn, turn same way as last time
SERTXD ("M")
  ON f_memturn GOSUB Rt,Lt
  RETURN
'-----------------------------------------
'Ot:  'OtherTurn, turn opposite way to last time
SERTXD ("O")
  ON f_memturn GOSUB Lt,Rt
  RETURN
'-----------------------------------------
Rt:
SERTXD ("R")
  IF paceat<paceC AND f_direction=1 THEN GOSUB Fd  'need left foot forward
  IF paceat<paceC AND f_direction=0 THEN GOSUB Bk  'need left foot forward
  IF f_Bfast=1 THEN GOSUB B_turn
  GOSUB _RF
  f_memturn =0
  RETURN
'-----------------------------------------
Lt:
SERTXD ("L")
  IF paceat>paceC AND f_direction=1 THEN GOSUB Fd  'need right foot forward
  IF paceat>paceC AND f_direction=0 THEN GOSUB Bk  'need right foot forward
  IF f_Bfast=1 THEN GOSUB B_turn
  GOSUB _LF
  f_memturn =1
  RETURN
'-----------------------------------------
Stand:  'stand with both feet flat
'SERTXD (" Sd")
  IF rollat<rollC THEN _StandR 'else _StandL
_StandL:
'SERTXD ("_SL")
  FOR spulse=rollat TO rollC STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_StandR:
'SERTXD ("_SR")
  FOR spulse=rollat TO rollC STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
'=================================================================
MOVEMENTS:
'---------

_RF:
'SERTXD ("_RF")
  paceto =paceC -paceby
  FOR spulse=paceat TO paceto STEP -pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_LF:
'SERTXD ("_LF")
  paceto =paceC +paceby
  FOR spulse=paceat TO paceto STEP pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
'-----------------------------------------
_rollL:
'SERTXD ("_rL")
  rollto =rollC -rollby
  FOR spulse=rollat TO rollto STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN

_rollR:
'SERTXD ("_rR")
  rollto =rollC +rollby
  FOR Spulse=rollat TO rollto STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
'-----------------------------------------
pulseservos:
  PULSOUT servoroll,rollat  'pulse servo
  PULSOUT servopace,paceat  'pulse servo
  PAUSE sframe
  RETURN
'-----------------------------------------
_iStand:
'initialise with feet in mid position
  FOR spulse=0 TO 10
    PULSOUT servopace,paceC  'pulse servo paceC
    PULSOUT servoroll,rollC  'pulse servo rollC
    PAUSE 70        'pause 70ms - do it slowly
   NEXT spulse
  rollat =rollC
  paceat =paceC
  RETURN
'=================================================================
COMMUNICATION:  'HMI - Human Machine Interface
'-------------

beep50:
  SOUND VoiceLed_,(50,10)
  HIGH VoiceLed_
  RETURN

beep255:
  SOUND VoiceLed_,(255,10)
  HIGH VoiceLed_
  RETURN

EyesOFF:
  pwmout eyeLedR_,off
  pwmout eyeLedL_,off
  HIGH eyeLedR_
  HIGH eyeLedL_
  RETURN

EyesON:
  LOW eyeLedR_
  LOW eyeLedL_
  RETURN

EyesDimmest:
  pwmout eyeLedR_,255,1023 'active low so high Dutycycle for dim,
  pwmout eyeLedL_,255,1023 'active low so high Dutycycle for dim,
  RETURN
'=================================================================
UTILITIES:
'---------
IRgetKey1to8:
IRgetAct_cmnd:
  IRIN inIR,cmnd      'key1 - key8 => 0-7
  IF cmnd<8 THEN _IRgetActEnd
  IF cmnd=KEY_POWER THEN RETURN ENDIF  'quit
  GOSUB badkey
  GOTO IRgetAct_cmnd  'repeat until valid act
_IRgetActEnd:
  GOSUB beep50
  RETURN

nokey:
  IRIN [50,_nokeyend],inIR,cmnd'IRIN timeout =>reurn
  GOTO nokey
_nokeyend:
  RETURN

badkey:
  LOW whiskerLedR_
  PAUSE 100
  HIGH whiskerLedR_
  LOW whiskerLedL_
  PAUSE 100
  HIGH whiskerLedL_
  RETURN
'=================================================================
SENSE:
'-----

QEwhiskerL:
  READADC eyeL,lightL
  lightL =lightL MIN 1
  LOW eyeLedL_              'eyeL on
  PAUSE 1
  READADC eyeL,eyelit
  HIGH  eyeLedL_            'eyeL off
  eyelit =eyelit MIN lightL MIN 1 'shouldn't be darker with LED on
  '                           if =0 then lightL=255 which is wrong
  lightL =eyelit -lightL *100 /eyelit 'find difference as %
    IF lightL>obsclearL THEN
    PEEK RAMobstaclesL,temp1
    temp1 =temp1 +Minc_obs MAX Mmax_obs   
    POKE RAMobstaclesL,temp1  'update memory
    f_mapL =1
   ENDIF
  RETURN  'lightL as % change, LEDon LEDoff


QEwhiskerR:
  READADC eyeR,lightR
  lightR =lightR MIN 1
  LOW eyeLedR_              'eyeR on
  PAUSE 1
  READADC eyeR,eyelit
  HIGH  eyeLedR_            'eyeR off
  eyelit =eyelit MIN lightR MIN 1 'shouldn't be darker with LED on
  '                           if =0 then lightR=255 which is wrong
  lightR =eyelit -lightR *100 /eyelit 'find difference as %
  IF lightR>obsclearR THEN
    PEEK RAMobstaclesR,temp1
    temp1 =temp1 +Minc_obs MAX Mmax_obs   
    POKE RAMobstaclesR,temp1    'update memory
    f_mapR =1
   ENDIF
  RETURN  'lightR as % change, LEDon LEDoff  

'----------------------------------------  
calibrateGwhiskers:
  Light =0  'clear temp Hi Lo
'take averages of 8 readings per whisker
  LOW whiskerLedL_        'eyeL on
  FOR i=0 TO 7
    READADC whiskerL,temp0
'SERTXD("L",#temp0)
    temp0 =temp0 /8
    lightL =lightL +temp0
'SERTXD(" ",#lightL,CR)
   NEXT i
  HIGH whiskerLedL_       'eyeL off
  LOW WhiskerLedR_        'eyeR on
  FOR I=0 TO 7
    READADC whiskerR,temp0
'SERTXD("R",#temp0)
    temp0 =temp0 /8
    lightR =lightR +temp0
'SERTXD(" ",#lightR,CR)
   NEXT i
  HIGH whiskerLedR_        'eyeR off
'set threshold at 60%
  lightL =lightL *3 /5        '60%
  lightR =lightR *3 /5        '60%
SERTXD("holethresh L",#lightL," R",#lightR,CR)
  POKE RAMholedetectL,lightL
  POKE RAMholedetectR,lightR
  RETURN

QGwhiskerL:
  LOW whiskerLedL_              'eyeL on
  PAUSE 1
  READADC whiskerL,whisklit
  HIGH whiskerLedL_             'eyeL off
  PEEK RAMholedetectL,LightL
  IF whisklit<LightL THEN
    PEEK RAMobstaclesL,temp1
    temp1 =temp1 +Minc_obs MAX Mmax_obs   
    POKE RAMobstaclesL,temp1    'update memory
    f_mapL =1
   ENDIF
  RETURN

QGwhiskerR:
  LOW whiskerLedR_              'eyeR on
  PAUSE 1
  READADC whiskerR,whisklit
  HIGH  whiskerLedR_            'eyeR off
  PEEK RAMholedetectR,LightR
  IF whisklit<LightR THEN
    PEEK RAMobstaclesR,temp1
    temp1 =temp1 +Minc_obs MAX Mmax_obs   
    POKE RAMobstaclesR,temp1    'update memory
    f_mapR =1
   ENDIF
  RETURN

'----------------------------------------
setUSawares:
  tempW0 =0
_setUSawares:
  GOSUB Qping
SERTXD("US",#usdist,CR)
  IF usdist=0 THEN
    GOSUB badkey
    GOTO setUSawares
   ENDIF
  'SERTXD("cmnd",#cmnd,CR)
  SELECT cmnd
    CASE KEY_PLUS
      'SERTXD("KEY_PLUS",CR)
      WRITE DUSawareAt,usdist
      'SERTXD("AwareAt=",#usdist,CR)
    CASE KEY_MINUS
      'SERTXD("KEY_MINUS",CR)
      WRITE DUStoonear,usdist
      'SERTXD("TooClose=",#usdist,CR)
    CASE KEY_POWER           'Quit
      'SERTXD("KEY_POWER",CR)
      GOSUB beep50           'done
      RETURN                 'RETURN
    ELSE
      GOSUB badkey
   ENDSELECT
_setUSawaresIRin:
  GOSUB beep50               'done cmnd
  IRIN inIR,cmnd
  GOTO _setUSawares

 
Qping:   'Query Ultrasonic Sensor, read into USdist
  LOW pingpin                ' make trigger 0-1-0
  #ifdef HCSR04
    SETFREQ m32              ' pulse resolution 1.25uS
   #endif
  PULSOUT pingpin,pingtrig   ' activate sensor
  PULSIN  pingpin,1,tempw0    ' measure high(=1) echo pulse in units,
                             ' 10us@4MHz, 1.25us@32MHz
        ' pulsin rolls over at 65536counts =>0
        ' ie 0.65536sec  @ 4MHz(10uS) too long to wait if nothing there
        '    0.081926sec @32MHz(1.25uS) tolerable
        ' so use 32MHz for HCSR04
        ' SRF05 auto times out at 36ms and returns 0, good.
  tempw0 =tempw0 ** USscalecm  'scale time to cm
  #ifdef inches
    tempw0 =tempw0 ** cmtoinch
   #endif
  IF tempw0=0 THEN             ' if timeout then
    usdist =255                ' set to max distance
   ELSE
    usdist =tempw0 MAX 255
   ENDIF
  #ifdef HCSR04
    SETFREQ m4         ' restore clock frequency
   #endif
  RETURN
  
#ifdef testUS          'save code space if not testing
testping:
  GOSUB Qping
SERTXD(#USdist,CR)
  TOGGLE VoiceLed_
  PAUSE 50
  GOTO testping
 #endif
 
'=================================================================